%global with_grizzly 1
Name:          jersey
Version:       1.17.1
Release:       %mkrel 3
Summary:       JAX-RS (JSR 311) production quality Reference Implementation
# One file in jersey-core/ is under ASL 2.0 license
License:       (CDDL or GPLv2 with exceptions) and ASL 2.0
Group:         Development/Java
URL:           http://jersey.java.net/
# svn export https://svn.java.net/svn/jersey~svn/tags/jersey-1.17.1/jersey jersey-1.17.1
# find jersey-1.17.1 -name '*.jar' -delete
# find jersey-1.17.1 -name '*.class' -delete
# tar czf jersey-1.17.1-src-svn.tar.gz jersey-1.17.1
Source0:       %{name}-%{version}-src-svn.tar.gz
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt

# change
#     com.sun.tools.xjc.maven2 maven-jaxb-plugin 1.1.1 with maven-jaxb2-plugin
#     aId weld-osgi-bundle with weld-core
#     aId osgi_R4_core with org.osgi.core
#     javax.servlet javax.servlet-api 3.0.1 with org.jboss.spec.javax.servlet jboss-servlet-api_3.0_spec
#     javax.servlet jsp-api 2.0 with org.jboss.spec.javax.servlet.jsp jboss-jsp-api_2.2_spec
#     org.glassfish javax.ejb 3.1 with org.jboss.spec.javax.ejb jboss-ejb-api_3.1_spec
#     org.glassfish.web el-impl 2.2 with org.apache.tomcat tomcat-jasper-el 7.0.27
# add geronimo-annotation
# fix ant and eclipselink aId
# resolved problem with missing weld-build-config
Patch0:        %{name}-1.14-fixbuild.patch
# remove org.aspectj aspectjrt
# remove testng classifier jdk15
# change javax.servlet servlet-api 2.5 with org.jboss.spec.javax.servlet jboss-servlet-api_3.0_spec
# change spring25-release-version [2.5.2,3) to 3
Patch1:        %{name}-1.15-contribs-spring-pom.patch

BuildRequires: java-devel

BuildRequires: ant
BuildRequires: eclipselink
BuildRequires: felix-osgi-core
BuildRequires: geronimo-annotation >= 1.0-7
BuildRequires: geronimo-jpa
BuildRequires: glassfish-fastinfoset
BuildRequires: glassfish-jaxb
BuildRequires: glassfish-jaxb-api
%if %with_grizzly
BuildRequires: grizzly
%endif
BuildRequires: jackson
BuildRequires: javamail
BuildRequires: jboss-ejb-3.1-api
BuildRequires: jboss-el-2.2-api
BuildRequires: jboss-jsp-2.2-api
BuildRequires: jboss-servlet-3.0-api
BuildRequires: jdom
BuildRequires: jettison
BuildRequires: jsr-311
BuildRequires: objectweb-asm
BuildRequires: rome >= 0.9-11
BuildRequires: tomcat-lib
BuildRequires: weld-core
BuildRequires: weld-parent

# tests deps
BuildRequires: apache-commons-codec
BuildRequires: apache-commons-io
BuildRequires: aspectjweaver
BuildRequires: cglib
BuildRequires: cobertura
BuildRequires: junit
BuildRequires: testng
BuildRequires: tomcat-lib

# contrib
BuildRequires: freemarker
BuildRequires: guice
BuildRequires: guice-extensions
BuildRequires: guice-servlet
BuildRequires: httpcomponents-client
BuildRequires: jakarta-commons-httpclient
BuildRequires: mimepull
#BuildRequires: simple >= 5.0.4 some B/R are not available
BuildRequires: springframework
BuildRequires: springframework-aop
BuildRequires: springframework-beans
BuildRequires: springframework-context
BuildRequires: springframework-web
BuildRequires: xerces-j2
# jersey maven-wald-plugin deps
BuildRequires: mvn(org.apache.maven:maven-artifact)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)
BuildRequires: mvn(org.apache.maven.plugins:maven-plugin-plugin)

BuildRequires: geronimo-parent-poms

BuildRequires: buildnumber-maven-plugin
BuildRequires: maven-local
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-istack-commons-plugin
BuildRequires: maven-jaxb2-plugin
BuildRequires: maven-plugin-build-helper
BuildRequires: maven-plugin-bundle
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-provider-junit4
BuildRequires: maven-surefire-provider-testng

BuildArch:     noarch

%description
Jersey is the open source JAX-RS (JSR 311)
production quality Reference Implementation
for building RESTful Web services.

%package test-framework
Summary:       Jersey Test Framework

%description test-framework
%{summary}.

%package contribs
Summary:       Contributions to Jersey

%description contribs
Projects that provide additional functionality to jersey,
like integration with other projects/frameworks.

%package -n maven-wadl-plugin
Summary:       WADL Maven Mojo

%description -n maven-wadl-plugin
A maven plugin that generates a wadl file
from resource classes and more stuff.

%package javadoc
Summary:       Javadoc for %{name}
Group:         Documentation

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q

%patch0 -p1
%patch1 -p0

# unavailable deps
%pom_disable_module archetypes
%pom_disable_module archive
%pom_disable_module experimental
%pom_disable_module glassfish
%pom_disable_module jersey-bundle
%pom_disable_module jersey-documentation
%pom_disable_module jersey-grizzly
%pom_disable_module jersey-tests
%pom_disable_module osgi
%pom_disable_module ri
%pom_disable_module samples
%pom_disable_module tests

%pom_disable_module jersey-test-framework-grizzly jersey-test-framework
%pom_disable_module jersey-test-framework-embedded-glassfish jersey-test-framework
%pom_disable_module bill-burke-book contribs
%pom_disable_module jersey-atom-abdera contribs
%pom_disable_module jersey-non-blocking-client contribs
%pom_disable_module oauth-tests contribs/jersey-oauth
%pom_disable_module scala contribs
%pom_disable_module jersey-simple-server contribs

# unavailable test deps
%pom_remove_dep com.sun.net.httpserver:http jersey-client

# disable embedded jsr-311 copy
%pom_remove_plugin :maven-dependency-plugin jersey-core


# [ERROR] 
# Artifact Ids of the format maven-___-plugin are reserved for 
# plugins in the Group Id org.apache.maven.plugins
# Please change your artifactId to the format ___-maven-plugin
# In the future this error will break the build.
sed -i 's|<artifactId>maven-wadl-plugin</artifactId>|<artifactId>wadl-maven-plugin</artifactId>|' \
  contribs/maven-wadl-plugin/pom.xml

# [ERROR] com.sun.jersey.wadl.GenerateWadlMojo#_wadlFile:
# [ERROR] Failed to execute goal org.apache.maven.plugins:maven-plugin-plugin:3.1:descriptor
# (default-descriptor) on project maven-wadl-plugin: Error extracting plugin descriptor:
# 'com.sun.jersey.wadl.GenerateWadlMojo#_wadlFile: cannot use both @parameter expression and property'
sed -i 's|property="wadlFile" expression="${project.build.directory}/application.wadl"|expression="${project.build.directory}/application.wadl"|' \
  contribs/maven-wadl-plugin/src/main/java/com/sun/jersey/wadl/GenerateWadlMojo.java

sed -i "s|<artifactId>apache-maven|<artifactId>maven-compat|" contribs/maven-wadl-plugin/pom.xml

%pom_remove_dep org.glassfish:javax.servlet jersey-grizzly2-servlet
%pom_add_dep org.jboss.spec.javax.servlet:jboss-servlet-api_3.0_spec jersey-grizzly2-servlet
# javax.servlet javax.servlet-api 3.0.1
%pom_remove_dep javax.servlet:javax.servlet-api jersey-test-framework/jersey-test-framework-core
%pom_add_dep org.jboss.spec.javax.servlet:jboss-servlet-api_3.0_spec jersey-test-framework/jersey-test-framework-core
# these test fails ( NOTE grizzly use servlet 3.1 apis, instead, jersey use servlet 3.0.1 apis )
rm -r contribs/jersey-apache-client/src/test/java/com/sun/jersey/client/apache/impl \
 jersey-test-framework/jersey-test-framework-grizzly2/src/test/java/com/sun/jersey/test/framework/impl/container/grizzlyweb2 \
 contribs/jersey-guice/src/test/java/com/sun/jersey/guice

# disable spring contribs tests. fails for various reasons
sed -i 's,<skip>${maven.test.skip}</skip>,<skip>true</skip>,' contribs/spring/pom.xml

%pom_add_dep commons-codec:commons-codec:any:test contribs/jersey-apache-client
%pom_add_dep commons-codec:commons-codec:any:test contribs/jersey-multipart
%pom_remove_dep org.jvnet:mimepull contribs/jersey-multipart
%pom_add_dep org.jvnet.mimepull:mimepull contribs/jersey-multipart
%pom_remove_dep javax.servlet:servlet-api contribs/jersey-guice
%pom_add_dep org.jboss.spec.javax.servlet:jboss-servlet-api_3.0_spec:any:provided contribs/jersey-guice
%pom_remove_dep ant:ant contribs/ant-wadl-task
%pom_add_dep org.apache.ant:ant:any:provided contribs/ant-wadl-task

%pom_remove_dep org.eclipse.persistence:org.eclipse.persistence.moxy contribs/jersey-moxy
%pom_add_dep org.eclipse.persistence:eclipselink contribs/jersey-moxy

# disable embedded jsr-311 copy
sed -i "s|<Export-Package>javax.ws.rs.*;-split-package:=merge-first,com.sun.jersey|<Export-Package>com.sun.jersey|" \
 jersey-core/pom.xml
sed -i "s|<Import-Package>!javax.ws.rs.*,javax.mail|<Import-Package>javax.ws.rs.*,javax.mail|" \
 jersey-core/pom.xml

for p in jersey-atom jersey-client jersey-fastinfoset jersey-json jersey-server contribs/jersey-moxy ;do
%pom_add_dep javax.ws.rs:jsr311-api ${p}
done
for p in contribs/jersey-oauth/oauth-signature ;do
%pom_add_dep javax.ws.rs:jsr311-api:any:test ${p}
done

# these tests fail
rm -r jersey-json/src/test/java/com/sun/jersey/json/impl/NamespaceElementTest.java \
 jersey-json/src/test/java/com/sun/jersey/json/impl/NamespaceSupportIssue272Test.java \
 jersey-json/src/test/java/com/sun/jersey/json/impl/NamespaceAttributeTest.java

cp -p %{SOURCE1} .
sed -i 's/\r//' LICENSE-2.0.txt

# fix aId for new istack-commons maven plugin
sed -i "s|<artifactId>maven-istack-commons-plugin|<artifactId>istack-commons-maven-plugin|" $(find . -name "pom.xml")

sed -i "s|<finalName>jersey-test-framework</finalName>||" \
jersey-test-framework/jersey-test-framework-core/pom.xml

# Add explicit dependency on tools.jar, see rhbz#1019234
%pom_add_dep com.sun:tools contribs/wadl-resourcedoc-doclet

%build

%mvn_file :%{name}-test-framework %{name}/%{name}-test-framework-pom
%mvn_file :%{name}-test-framework-core %{name}/%{name}-test-framework
%mvn_file :%{name}-test-framework-core %{name}/%{name}-test-framework-core
%mvn_package ":%{name}-test-framework" test-framework
%mvn_package ":%{name}-test-framework-core" test-framework 
%mvn_package ":%{name}-test-framework-external" test-framework
%mvn_package ":%{name}-test-framework-grizzly2" test-framework
%mvn_package ":%{name}-test-framework-http" test-framework
%mvn_package ":%{name}-test-framework-inmemory" test-framework
# contribs   %%{name}-simple-server
%mvn_package ":%{name}-contribs" contribs
%mvn_package ":ant-wadl-task" contribs
%mvn_package ":%{name}-apache-client" contribs
%mvn_package ":%{name}-apache-client4" contribs
%mvn_package ":%{name}-freemarker" contribs
%mvn_package ":%{name}-guice" contribs
%mvn_package ":%{name}-moxy" contribs
%mvn_package ":%{name}-multipart" contribs
%mvn_package ":%{name}-oauth" contribs
%mvn_package ":%{name}-spring" contribs
%mvn_package ":%{name}-wadl-json-schema" contribs
%mvn_package ":oauth-client" contribs
%mvn_package ":oauth-server" contribs
%mvn_package ":oauth-signature" contribs
%mvn_package ":wadl-resourcedoc-doclet" contribs
%mvn_package ":wadl-maven-plugin" maven-wadl-plugin

%mvn_build -- -P "!jdk1.7"

%install
%mvn_install

mkdir -p %{buildroot}%{_sysconfdir}/ant.d
echo "ant %{name}/%{name}-server jaxb-api" > ant-wadl-task
install -p -m 644 ant-wadl-task %{buildroot}%{_sysconfdir}/ant.d/ant-wadl-task

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc changes.txt dependencies.html getting-started.html license.html legal/LICENSE.txt legal/maintenance/copyright.txt LICENSE-2.0.txt

%files test-framework -f .mfiles-test-framework
%doc license.html legal/LICENSE.txt legal/maintenance/copyright.txt

%files contribs -f .mfiles-contribs
%config(noreplace) %{_sysconfdir}/ant.d/ant-wadl-task
%doc license.html legal/LICENSE.txt legal/maintenance/copyright.txt

%files -n maven-wadl-plugin -f .mfiles-maven-wadl-plugin
%doc license.html legal/LICENSE.txt legal/maintenance/copyright.txt

%files javadoc -f .mfiles-javadoc
%doc license.html legal/LICENSE.txt legal/maintenance/copyright.txt LICENSE-2.0.txt



%changelog
* Wed Jan 01 2014 dmorgan <dmorgan> 1.17.1-3.mga4
+ Revision: 563702
- Rebuild with fixed springframework

* Tue Oct 22 2013 umeabot <umeabot> 1.17.1-2.mga4
+ Revision: 544950
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 dmorgan <dmorgan> 1.17.1-1.mga4
+ Revision: 500558
- Add explicit dependency on tools.jar
- Resolves: rhbz#1019234
- New version

* Mon Feb 18 2013 dmorgan <dmorgan> 1.9.1-5.mga3
+ Revision: 398980
- Build w/o geronimo-stax-1.2-api

* Sat Jan 12 2013 umeabot <umeabot> 1.9.1-4.mga3
+ Revision: 355318
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 dmorgan <dmorgan> 1.9.1-3.mga3
+ Revision: 342986
- Remove findbugs-maven-plugin deps

* Sun Jun 24 2012 gil <gil> 1.9.1-2.mga3
+ Revision: 263271
- fix BR
- added weld support
- built server and server-linking libraries

* Sat Dec 03 2011 gil <gil> 1.9.1-1.mga2
+ Revision: 175557
- remove patch7 built with jvnet-parent support
- build fix
  added OSGi support
- changes removed for jersey-server
- build fix
  added proper BR version/release
- imported package jersey

